clear; clc;

%% nastaven parametr

% pesnost vpotu
odchylka = 0.5;

% velikost obrazu a slovnku
l = 4;
m = 3;
n = 8;

%% konstrukce nhodnho obrazu

% generovn zkuebnho slovnku
a = randn(m,n);

% normovn zkuebnho slovnku
for i=1:n
    a(:,i) = a(:,i)/norm(a(:,i));
end

% generovn dkch signl vzniklch linern kombinac nkolika sloupc slovnku
Y = zeros(m,l);

pocet = randi(n/4);
for i=1:l
    cisla = randperm(n);
    pozice = sort(cisla(1:pocet));
    koef = randi(n/2,pocet,1);
    Y(:,i) = a(:,pozice)*koef;
end




%% vlastn algoritmus

% vygenerovn nhodnho slovnku
A = randn(m,n);

% normovn slovnku
for i=1:n
    A(:,i) = A(:,i)/norm(A(:,i));
end

% hledn dkho een
X = zeros(n,l);

opakuj = 1;

for k = 1: 1000
    for i=1:l
        X(:,i) = MP(A,Y(:,i),odchylka);
    end

    % svd rozklad a aktualizace slovnku
    pom = ones(m,1);
    for i=1:n
        for j=1:n
            if j~=i
                E = Y - A(:,j)*X(j,:);
            end
        end
        om = logical(X(i,:));
        omega = logical(kron(om,pom));
        Er = E(omega);
        Er = reshape(Er,m,[]);
        [U,S,V] = svd(Er);
        A(:,i) = U(:,1);
        if not(isempty(V))
            Xr = S(1,1)*V(:,1);
            poc = 0;
            for j=1:l
                if om(j) == 1
                    poc = poc+1;
                    X(i,j) = Xr(poc);
                end
            end
        end
    end
    display(num2str(opakuj));
    opakuj = opakuj +1;
    if norm(Y-A*X) < 0.5
        break;
    end
end


%% vykreslen vsledk
subplot(4,2,1)
imagesc(a);
axis equal;
axis off;
title('pvodn slovnk');

subplot(4,2,2)
imagesc(Y);
axis equal;
axis off;
title('pvodn signly');

subplot(4,2,3)
imagesc(A);
axis equal;
axis off;
title('nalezen slovnk');

subplot(4,2,4)
imagesc(A*X);
axis equal;
axis off;
title('vyjden signl pomoc nalezenho slovnku');

% vpoet odchylky pvodnch signl a zptn zrekonstruovanch
norma = norm(A*X - Y);
PSNR = psnr(A*X, Y);
display(['rozdl obou obraz v norm = ' num2str(norma)])
display(['PSNR = ' num2str(PSNR) ' dB'])