clear; clc;

% naten obrazu
obraz = im2double(imread('lena-orig.png'));

try
    obraz = rgb2gray(obraz);
end

% nastaven dkosti
ridkost = false;
if ridkost
    k = 20; 
end
% nastaven zaumn
zasumeni = false;
if zasumeni
    smerodatna_odchylka = 0.3;
end

% nastaven bze - monosti: DCT, haar, db1, db2, db3, db4, db5, db6, db7, db8, db9, db10
baze = 'haar';

% nastaven pesnosti een
presnost = 0.1;

% velikost obrazu
m = size(obraz,1);
n =  size(obraz,2);

% poet dl rozdlenho obrazu
deleni = 8;
a = m/deleni;
b = n/deleni;

% vytvoen bze
[baze_m,baze_n] =  vytvoreni_baze(baze,m,n);

% tvorba ekvivalentnho slovnku
[baze_1,baze_2] =  vytvoreni_baze(baze,deleni,deleni);
A = kron(baze_2',baze_1');

% oznut koeficient na danou dkost
Obraz = obraz;
if ridkost
    for i = 1:a
        for j = 1:b
            radek = ((i-1)*deleni + 1):i*deleni;
            sloupec = ((j-1)*deleni + 1):j*deleni;
        
            koeficienty = baze_1 * obraz(radek,sloupec) * baze_2';
            vektor_koeficienty = koeficienty(:);
            poradi = sort(abs(vektor_koeficienty));
            hranice = poradi(deleni*deleni - k);
            nuluj = find(koeficienty < hranice);
            koeficienty(nuluj) = 0;
            Obraz(radek,sloupec) = baze_1' * koeficienty * baze_2;
        end
    end
    obraz = Obraz;
    if zasumeni
        Obraz = Obraz + smerodatna_odchylka*randn(m,n);
    end
else
    if zasumeni
        Obraz = obraz + smerodatna_odchylka*randn(m,n);
    end
end

%% rekonstrukce pvodnho obrazu

 x_mp = zeros(m,n);
 obrazek = zeros(m,n);
for i = 1:a
    for j = 1:b
        
        radek = ((i-1)*deleni + 1):i*deleni;
        sloupec = ((j-1)*deleni + 1):j*deleni;
        
        Y =  Obraz(radek,sloupec);
        y = Y(:);
        
        % rekostrukce pvodnho obrazu jednotlivmi metodami
        X_mp = MP(A,y,presnost);
        x_mp(radek,sloupec) =reshape(X_mp,deleni,deleni);
        obrazek(radek,sloupec) = baze_1'*x_mp(radek,sloupec)*baze_2;
        
    end
end

%% vykreslen pvodnho obrazu a zptn zrekonstruovanch

subplot(1,2,1);
if zasumeni
    imagesc(Obraz)
else
    imagesc(obraz)
end
colormap(gray)
title('vchoz obraz')
axis off;
axis equal;

subplot(1,2,2);
imagesc(obrazek)
colormap(gray)
title('obraz nalezen pomoc MP')
axis off;
axis equal;

% vpoet odchylky pvodnho obrazu a zptn zrekonstruovanho
norma = norm(obraz - obrazek)/norm(obraz);
PSNR = psnr(obraz, obrazek);
display(['relativn chyba een = ' num2str(norma)])
display(['PSNR = ' num2str(PSNR) ' dB'])