clear; clc;

%% voliteln parametry

% dkost
k = 10; 

% velikost obrazu
m = 5; 
n = 10;

% nastaven bze
baze = 'DCT';

% povolen maximln nepesnost
e = 0.001; 

% rozsah smrodatnch odchylek
s = 0:25; 

% poet opakovn s jednotlivmi smrodatnmi odchylkami
pocet = 50;

% nastaven velikosti kroku pi vpotu optimlnho lambda
h = 0.01;

%% vygenerovn dkho obrazu

[X,Y] = generovani_ridkeho_signalu(k, m ,n, baze);
X = X(:);

%% rekonstrukce pvodnho obrazu

bazeDCTm = dctmtx(m);
bazeDCTn = dctmtx(n);

% vytvoen slovnku
M = eye(n);
A = kron(M,bazeDCTm');

% poten nastaven pi vpotu
lambda = 0:h:1; 
pocet_odchylek = length(s);
minimalni_lambda = zeros(1,pocet);
min_lambda = zeros(1,pocet_odchylek);

% hledn minimlnho lambda
for l = 1:pocet_odchylek
    
    for j = 1:pocet
    chyba = zeros(length(lambda),1);
    
    % zaumn pvodnho obrazu
    y = (Y+s(l)*randn(m,n))*bazeDCTn';
    y = y(:);
    
    for i=1:length(lambda)
    
    x = IRLSe(y,A,lambda(i),e);
   
    chyba(i) = norm(x - X)/norm(X);
   
    end
        koef = find(chyba == min(chyba));
        minimalni_lambda(j) = lambda(koef);
    end
   % nalezen optimlnho lambda
    min_lambda(l) = sum(minimalni_lambda)/pocet;
    disp([ 'optimln lambda = ' num2str(min_lambda(l)) ' pro smrodatnou odchylku = ' num2str( s(l))]);
    
end

% proloen dat kivkou
[odhad_lambda,koeficienty_paraboly] = prolozeni_krivkou(s',min_lambda');

% vypsn rovnice proloen kivky
disp([ 'rovnice optimlnho lambda = ' num2str(koeficienty_paraboly(1)) '  +  ' num2str(koeficienty_paraboly(2)) ' odchylka +  ' num2str(koeficienty_paraboly(3)) 'odchylka^2 + ' num2str(koeficienty_paraboly(4)) 'odchylka^3']);

% vykreslen grafu
plot(s,min_lambda,'x');
hold on;
plot(s,odhad_lambda,'r');
xlabel('smrodatn odchylka');
ylabel('optimln lambda');