clear; clc;

%% nastaven parametr

% dkost
k = 7;

% velikost obrazu
m = 3;
n = 5;

% nastaven pesnosti een
odchylka = 0.01;

% nastaven hodnoty odchylky, kdy jsme jet s eenm spokojeni
tolerance = 0.005;

% smrodatn odchylky umu
s = 0:0.1:1;

% poet opakovn rekonstrukce s danm umem
c = 100;

% nastaven bze - monosti: DCT, haar, db1, db2, db3, db4, db5, db6, db7, db8, db9, db10
baze = 'DCT';

%% vygenerovn  dkho obrazu
[koeficienty,ridkyobraz,baze_m,baze_n] = generovani_ridkeho_signalu(k, m ,n,baze);

%% rekonstrukce pvodnho obrazu

% tvorba ekvivalentnho slovnku
A = kron(baze_n',baze_m');

% pprava na vpoet - nastaven parametr a deklarace velikosti nkterch promnnch
poc = 0;
normay = norm(ridkyobraz);
ch_mp = zeros(1,c);
ch_omp = zeros(1,c);
ch_irls = zeros(1,c);
chyba_mp = zeros(1,length(s));
chyba_omp = zeros(1,length(s));
chyba_irls = zeros(1,length(s));
rek_mp = zeros(1,c);
rek_omp = zeros(1,c);
rek_irls = zeros(1,c);
rekonstrukce_mp = zeros(1,length(s));
rekonstrukce_omp = zeros(1,length(s));
rekonstrukce_irls = zeros(1,length(s));

% postupn pidvn umu a zptn rekonstrukce pvodnho obrazu
for i = s
    for j = 1:c
        
        Y = (ridkyobraz+i*randn(m,n));
        y = Y(:);


        X_mp = MP(A,y,odchylka);
        x_mp = reshape(X_mp,m,n);
        ch_mp(j) = norm(ridkyobraz - baze_m'*x_mp*baze_n)/ normay;
        if ch_mp(j) < tolerance
            rek_mp(j) = 1;
        else
            rek_mp(j) = 0;
        end

        X_omp = OMP(A,y,odchylka);
        x_omp = reshape(X_omp,m,n);
        ch_omp(j) = norm(ridkyobraz - baze_m'*x_omp*baze_n)/ normay;
        if ch_omp(j) < tolerance
            rek_omp(j) = 1;
        else
            rek_omp(j) = 0;
        end


        X_irls = IRLS(A,y,odchylka);
        x_irls = reshape(X_irls,m,n);
        ch_irls(j) = norm(ridkyobraz - baze_m'*x_irls*baze_n)/ normay;
        if ch_irls(j) < tolerance
            rek_irls(j) = 1;
        else
            rek_irls(j) = 0;
        end
        
    end
    poc = poc+1;
    
%     spotn prmrn chyby v jednotlivch opakovnch
    chyba_mp(poc) = sum(ch_mp)/c;
    chyba_omp(poc) = sum(ch_omp)/c;
    chyba_irls(poc) = sum(ch_irls)/c;
    rekonstrukce_mp(poc) = sum(rek_mp)/c;
    rekonstrukce_omp(poc) = sum(rek_omp)/c;
    rekonstrukce_irls(poc) = sum(rek_irls)/c;
    
end



%% vykreslen zvislosti relativn chyby  a spnost rekonstrukce na rozptylu

subplot(3,2,1);
plot(s,chyba_mp);
title('MP')
xlabel('smrodatn odchylka');
ylabel('relativn chyba');

subplot(3,2,3);
plot(s,chyba_omp);
title('OMP')
xlabel('smrodatn odchylka');
ylabel('relativn chyba');

subplot(3,2,5);
plot(s,chyba_irls);
title('IRLS')
xlabel('smrodatn odchylka');
ylabel('relativn chyba');

subplot(3,2,2);
plot(s,rekonstrukce_mp);
title('MP')
xlabel('smrodatn odchylka');
ylabel('spnost rekonstrukc');

subplot(3,2,4);
plot(s,rekonstrukce_omp);
title('OMP')
xlabel('smrodatn odchylka');
ylabel('spnost rekonstrukc');

subplot(3,2,6);
plot(s,rekonstrukce_irls);
title('IRLS')
xlabel('smrodatn odchylka');
ylabel('spnost rekonstrukc');