clear; clc;

%% nastaven parametr

% dkost
k = 3; 

% rozmry obrazu
m = 5;
n = 5;

% nastaven bze - monosti: DCT, haar, db1, db2, db3, db4, db5, db6, db7, db8, db9, db10
baze = 'DCT';

% nastaven pesnosti een
odchylka = 0.001;

% nastaven, zda chceme poutmc matici
mereni = true;
if mereni
    % nastaven pomru stran mc matice (men strany ku vt)
    pomer = 3/5;
end

%% vygenerovn dkho obrazu

[koeficienty,y,baze_m,baze_n] = generovani_ridkeho_signalu(k, m ,n,baze);

%% rekonstrukce pvodnho obrazu

%provedeni mereni (pokud ho mme nastaveno)
if mereni
    merici_matice1 = randn(pomer*m,m);
    merici_matice2 = randn(n,pomer*n);
    Y = merici_matice1*y*merici_matice2;
else
    Y = y;
end

% tvorba ekvivalentnho slovnku
if mereni
    A = kron(merici_matice2'*baze_n',merici_matice1*baze_m');
else
    A = kron(baze_n',baze_m');
end


% transformace obrazu do vektoru
Y = Y(:);

% rekostrukce pvodnho obrazu jednotlivmi metodami
X_mp = MP(A,Y,odchylka);
x_mp = reshape(X_mp,m,n);

X_omp = OMP(A,Y,odchylka);
x_omp = reshape(X_omp,m,n);

X_irls = IRLS(A,Y,odchylka);
x_irls = reshape(X_irls,m,n);

%% vykreslen pvodnho obrazu a zptn zrekonstruovanch

subplot(2,2,1);
imagesc(koeficienty)
title('vygenerovan dk koeficienty')
axis off;
axis equal;

subplot(2,2,2);
imagesc(x_mp)
title('MP')
axis off;
axis equal;

subplot(2,2,3);
imagesc(x_omp)
title('OMP')
axis off;
axis equal;

subplot(2,2,4);
imagesc(x_irls)
title('IRLS')
axis off;
axis equal;

% vpoet odchylky pvodnho obrazu a zptn zrekonstruovanch

norma_mp = norm(baze_m'*x_mp*baze_n - y)/norm(y);
norma_omp = norm(baze_m'*x_omp*baze_n - y)/norm(y);
norma_irls = norm(baze_m'*x_irls*baze_n - y)/norm(y);

PSNR_mp = psnr(baze_m'*x_mp*baze_n, y);
PSNR_omp = psnr(baze_m'*x_omp*baze_n, y);
PSNR_irls = psnr(baze_m'*x_irls*baze_n, y);

display(['relativn chyba een zskanho pomoc MP  = ' num2str(norma_mp)])
display(['PSNR_MP  = ' num2str(PSNR_mp) ' dB'])

display(['relativn chyba een zskanho pomoc OMP v norm = ' num2str(norma_omp)])
display(['PSNR_OMP  = ' num2str(PSNR_omp) ' dB'])

display(['relativn chyba een zskanho pomoc IRLS v norm = ' num2str(norma_irls)])
display(['PSNR_IRLS  = ' num2str(PSNR_irls) ' dB'])