clear; clc;

%% nastaven parametr

% rozmry obrazu
m = 15;
n = 15;

% nastaven bze - monosti: DCT, haar, db1, db2, db3, db4, db5, db6, db7, db8, db9, db10
baze = 'DCT';

% nastaven pesnosti een
odchylka = 0.1;

% nastaven hodnoty odchylky, kdy jsme jet s eenm spokojeni
tolerance = 0.1;

% poet opakovn rekonstrukce 
opakuj = 10;

% nastaven pomru stran mc matice (men strany ku vt)
pomer = 1/15:1/15:1;

% dkost
k = 15:15:m*n; 

% vbr metody - monosti: MP, OMP, IRLS
metoda = 'OMP';


ch = zeros(1,opakuj);
rek = zeros(1,opakuj);
rekonstrukce = zeros(length(k),length(pomer));

for i = length(k):-1:1
    for j = 1:length(pomer)
        for l = 1:opakuj
            
            %% vygenerovn dkho obrazu

            [koeficienty,y,baze_m,baze_n] = generovani_ridkeho_signalu(k(i), m ,n,baze);

            %% rekonstrukce pvodnho obrazu

            normay = norm(y);
            
            %provedeni mereni
            merici_matice1 = randn(pomer(j)*m,m);
            merici_matice2 = randn(n,pomer(j)*n);
            Y = merici_matice1*y*merici_matice2;

            % tvorba ekvivalentnho slovnku
            A = kron(merici_matice2'*baze_n',merici_matice1*baze_m');

            % transformace obrazu do vektoru
            Y = Y(:);

            % rekostrukce pvodnho obrazu 
            switch metoda
    
                case 'MP'
                    X = MP(A,Y,odchylka);
                    x = reshape(X,m,n);
            
                case 'OMP'
                    X = OMP(A,Y,odchylka);
                    x = reshape(X,m,n);
            
                case 'IRLS'
                    X = IRLS(A,Y,odchylka);
                    x = reshape(X,m,n);

            end
            
             ch(j) = norm(y - baze_m'*x*baze_n)/ normay;
            if ch(j) < tolerance
                rek(j) = 1;
            else
                rek(j) = 0;
            end
           
        end
        
        rekonstrukce(i,j) = sum(rek)/opakuj;
    end
end

imagesc(rekonstrukce)
xlabel('pomr stran mc matice x') 
ylabel('k x')
axis equal;
colorbar